// Sprite behaviour tests at the edge of the screen.
// Also 1st new neslib program

#define UPDATE_LIST_SIZE	30
#define MSB(x)				((x)>>8)
#define LSB(x)				((x)&0xff)
#define SPRITE_ADJUST		7

// na_th_an 20151209

#include "neslib.h"

// Those are from chase.

const unsigned char palGame1 [] = { 
	0x0f, 0x11, 0x32, 0x30, 0x0f, 0x1c, 0x2c, 0x3c, 0x0f, 0x09, 0x27, 0x38, 0x0f, 0x11, 0x21, 0x31 
};

const unsigned char palGameSpr [] = { 
	0x0f, 0x0f, 0x29, 0x30, 0x0f, 0x0f, 0x26, 0x30, 0x0f, 0x0f, 0x24, 0x30, 0x0f, 0x0f, 0x21, 0x30 
};

const unsigned char sprPlayer [] = {
	0,  0, 0x49, 0, 
	8,  0, 0x4a, 0, 
	0,  8, 0x4b, 0, 
	8,  8, 0x4c, 0, 
	128
};

// Some variables

#pragma bssseg (push,"ZEROPAGE")
#pragma dataseg(push,"ZEROPAGE")

unsigned char prx, pry;
unsigned char i, gpit, gpjt;
unsigned char *gp_gen;
unsigned int gp_addr;
signed int a;

#pragma bssseg (push,"BSS")
#pragma dataseg(push,"BSS")

static unsigned char update_list [UPDATE_LIST_SIZE * 3 + 1];
static unsigned char update_list_index;

void p_t3 (unsigned char x, unsigned char y, unsigned char n) {
	gp_addr = 0x2000 + (y << 5) + x;
	update_list [update_list_index ++] = MSB ((unsigned int) gp_addr);
	update_list [update_list_index ++] = LSB ((unsigned int) gp_addr ++);
	update_list [update_list_index ++] = (n / 100) + 16;

	update_list [update_list_index ++] = MSB ((unsigned int) gp_addr);
	update_list [update_list_index ++] = LSB ((unsigned int) gp_addr ++);
	update_list [update_list_index ++] = ((n % 100) / 10) + 16;
	
	update_list [update_list_index ++] = MSB ((unsigned int) gp_addr);
	update_list [update_list_index ++] = LSB ((unsigned int) gp_addr);
	update_list [update_list_index ++] = ((n % 10)) + 16;
}

void p_t5 (unsigned char x, unsigned char y, unsigned int n) {
	gp_addr = 0x2000 + (y << 5) + x;
	update_list [update_list_index ++] = MSB ((unsigned int) gp_addr);
	update_list [update_list_index ++] = LSB ((unsigned int) gp_addr++);
	update_list [update_list_index ++] = (n / 10000) + 16;

	update_list [update_list_index ++] = MSB ((unsigned int) gp_addr);
	update_list [update_list_index ++] = LSB ((unsigned int) gp_addr ++);
	update_list [update_list_index ++] = ((n / 1000) % 10) + 16;

	update_list [update_list_index ++] = MSB ((unsigned int) gp_addr);
	update_list [update_list_index ++] = LSB ((unsigned int) gp_addr ++);
	update_list [update_list_index ++] = ((n % 1000) / 100) + 16;

	update_list [update_list_index ++] = MSB ((unsigned int) gp_addr);
	update_list [update_list_index ++] = LSB ((unsigned int) gp_addr ++);
	update_list [update_list_index ++] = ((n % 100) / 10) + 16;
	
	update_list [update_list_index ++] = MSB ((unsigned int) gp_addr);
	update_list [update_list_index ++] = LSB ((unsigned int) gp_addr);
	update_list [update_list_index ++] = ((n % 10)) + 16;
}

void clear_update_list (void) {
	gpit = 1 + UPDATE_LIST_SIZE * 3;
	while (gpit --) update_list [gpit] = 0;
	update_list_index = 0;
}

void main (void) {
	// Init
pal_col (0,0);

	bank_spr (1);
	bank_bg (0);

	ppu_off ();

	vram_adr (0x2000);
	vram_fill (0x44, 960);
	vram_fill (0, 64);

	pal_bg (palGame1);
	pal_spr (palGameSpr);
	pal_bright (4);

	prx = 128;
	
	a = 160 << 6;
	pry = a >> 6;

	ppu_on_all ();
	
	set_vram_update (30, update_list);

	// Do
	
	while (1) {
		clear_update_list ();

		i = pad_poll (0);
		if (i & PAD_LEFT) prx --;
		if (i & PAD_RIGHT) prx ++;

		oam_meta_spr (prx, pry, 0, sprPlayer);

		p_t3 (0, 1, prx);
		p_t3 (4, 1, pry);
		p_t5 (8, 1, a);

		// Next frame
		ppu_waitnmi ();		
	}
}

